diff --git a/Makefile b/Makefile
index 21d5d72e7..887314779 100644
--- a/Makefile
+++ b/Makefile
@@ -368,6 +368,7 @@ units: mod core lib $(UNITS_OBJ) $(MOD_OBJ)
 	@$(CC) -o $(PREFIX)/test/modunit_tftp.elf $(CFLAGS) -I. test/unit/modunit_pico_tftp.c  -lcheck -lm -pthread -lrt $(UNITS_OBJ) $(PREFIX)/lib/libpicotcp.a
 	@$(CC) -o $(PREFIX)/test/modunit_sntp_client.elf $(CFLAGS) -I. test/unit/modunit_pico_sntp_client.c -lcheck -lm -pthread -lrt $(UNITS_OBJ)
 	@$(CC) -o $(PREFIX)/test/modunit_ipfilter.elf $(CFLAGS) -I. test/unit/modunit_pico_ipfilter.c stack/pico_tree.c -lcheck -lm -pthread -lrt $(UNITS_OBJ)
+	@$(CC) -o $(PREFIX)/test/modunit_aodv.elf $(CFLAGS) -I. test/unit/modunit_pico_aodv.c  -lcheck -lm -pthread -lrt $(UNITS_OBJ) $(PREFIX)/lib/libpicotcp.a
 	@$(CC) -o $(PREFIX)/test/modunit_queue.elf $(CFLAGS) -I. test/unit/modunit_queue.c  -lcheck -lm -pthread -lrt $(UNITS_OBJ)
 
 devunits: mod core lib
diff --git a/modules/pico_aodv.c b/modules/pico_aodv.c
index b94d01ef2..f60060fbc 100644
--- a/modules/pico_aodv.c
+++ b/modules/pico_aodv.c
@@ -86,9 +86,11 @@ static void aodv_elect_route(struct pico_aodv_node *node, union pico_address *gw
         pico_ipv4_route_del(node->dest.ip4, HOST_NETMASK, node->metric);
         if (!gw) {
             pico_ipv4_route_add(node->dest.ip4, HOST_NETMASK, ANY_HOST, 1, pico_ipv4_link_by_dev(dev));
+            printf("Added neighbor %08x\n", node->dest.ip4);
             node->metric = 1;
         } else {
             node->metric = metric;
+            printf("Added node %08x via %08x metric %d\n", node->dest.ip4, gw->ip4, metric);
             pico_ipv4_route_add(node->dest.ip4, HOST_NETMASK, gw->ip4, metric, NULL);
         }
     }
@@ -343,7 +345,7 @@ static void aodv_parse_rerr(union pico_address *from, uint8_t *buf, int len, str
     (void)buf;
     (void)len;
     (void)msginfo;
-    /* TODO: invalidate routes... */
+    /* TODO: invalidate routes. This only makes sense if we are using HELLO messages. */
 }
 
 static void aodv_parse_rack(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo)
diff --git a/modules/pico_ipv4.c b/modules/pico_ipv4.c
index ee9a63d03..6aa89e2b4 100644
--- a/modules/pico_ipv4.c
+++ b/modules/pico_ipv4.c
@@ -1379,7 +1379,7 @@ static int pico_ipv4_frame_sock_push(struct pico_protocol *self, struct pico_fra
 }
 
 
-int pico_ipv4_route_add(struct pico_ip4 address, struct pico_ip4 netmask, struct pico_ip4 gateway, int metric, struct pico_ipv4_link *link)
+int MOCKABLE pico_ipv4_route_add(struct pico_ip4 address, struct pico_ip4 netmask, struct pico_ip4 gateway, int metric, struct pico_ipv4_link *link)
 {
     struct pico_ipv4_route test, *new;
     test.dest.addr = address.addr;
@@ -1541,7 +1541,7 @@ static int pico_ipv4_cleanup_routes(struct pico_ipv4_link *link)
     return 0;
 }
 
-void pico_ipv4_route_set_bcast_link(struct pico_ipv4_link *link)
+void MOCKABLE pico_ipv4_route_set_bcast_link(struct pico_ipv4_link *link)
 {
     if (link)
         default_bcast_route.link = link;
diff --git a/modules/pico_olsr.c b/modules/pico_olsr.c
index dc1bd6ece..6feae50a2 100644
--- a/modules/pico_olsr.c
+++ b/modules/pico_olsr.c
@@ -15,6 +15,7 @@
 #ifdef PICO_SUPPORT_OLSR
 #define DGRAM_MAX_SIZE (100 - 28)
 #define MAX_OLSR_MEM (4 * DGRAM_MAX_SIZE)
+#define olsr_dbg(...) do{}while(0)
 
 int OOM(void);
 
@@ -140,7 +141,7 @@ static struct olsr_route_entry *get_next_hop(struct olsr_route_entry *dst)
 {
     struct olsr_route_entry *hop = dst;
     while(hop) {
-        /* dbg("Finding next hop to %08x m=%d\n", hop->destination.addr, hop->metric); */
+        /* olsr_dbg("Finding next hop to %08x m=%d\n", hop->destination.addr, hop->metric); */
         if(hop->metric <= 1)
             return hop;
 
@@ -165,7 +166,7 @@ static inline void olsr_route_add(struct olsr_route_entry *el)
         el->next = el->gateway->children;
         el->gateway->children = el;
         el->link_type = OLSRLINK_MPR;
-        dbg("[OLSR]  ----------Adding route to %08x via %08x metric %d\n", el->destination.addr, nexthop->destination.addr, el->metric);
+        olsr_dbg("[OLSR]  ----------Adding route to %08x via %08x metric %d\n", el->destination.addr, nexthop->destination.addr, el->metric);
         pico_ipv4_route_add(el->destination, HOST_NETMASK, nexthop->destination, (int) el->metric, NULL);
     } else if (el->iface) {
         /* neighbor */
@@ -181,7 +182,7 @@ static inline void olsr_route_add(struct olsr_route_entry *el)
             ei->children = el;
         }
 
-        dbg("[OLSR]  ----------Adding neighbor %08x iface %s\n", el->destination.addr, el->iface->name);
+        olsr_dbg("[OLSR]  ----------Adding neighbor %08x iface %s\n", el->destination.addr, el->iface->name);
 
         pico_ipv4_route_add(el->destination, HOST_NETMASK, no_gw, 1, pico_ipv4_link_by_dev(el->iface));
     }
@@ -190,7 +191,7 @@ static inline void olsr_route_add(struct olsr_route_entry *el)
 static inline void olsr_route_del(struct olsr_route_entry *r)
 {
     struct olsr_route_entry *cur, *prev = NULL, *lst;
-    /* dbg("[OLSR] DELETING route..................\n"); */
+    /* olsr_dbg("[OLSR] DELETING route..................\n"); */
     my_ansn++;
     if (r->gateway) {
         lst = r->gateway->children;
@@ -206,7 +207,7 @@ static inline void olsr_route_del(struct olsr_route_entry *r)
             /* found */
             if (r->gateway) {
                 pico_ipv4_route_del(r->destination, HOST_NETMASK, r->metric);
-                dbg("[OLSR] Deleting route to %08x \n", r->destination.addr);
+                olsr_dbg("[OLSR] Deleting route to %08x \n", r->destination.addr);
                 if (!prev)
                     r->gateway->children = r->next;
                 else
@@ -253,7 +254,7 @@ static struct olsr_route_entry *get_route_by_address(struct olsr_route_entry *ls
 uint8_t seconds2olsr(uint32_t seconds)
 {
     uint16_t a, b;
-    /* dbg("seconds=%u\n", (uint16_t)seconds); */
+    /* olsr_dbg("seconds=%u\n", (uint16_t)seconds); */
 
     if (seconds > 32767)
         seconds = 32767;
@@ -265,16 +266,16 @@ uint8_t seconds2olsr(uint32_t seconds)
             break;
         }
     }
-    /* dbg("b=%u", b); */
+    /* olsr_dbg("b=%u", b); */
     /* compute the expression 16*(T/(C*(2^b))-1), which may not be a
        integer, and round it up.  This results in the value for 'a' */
     /* a = (T / ( C * (1u << b) ) ) - 1u; */
     {
         uint16_t den = ((uint16_t)(1u << b) >> 4u);
-        /* dbg(" den=%u ", den); */
+        /* olsr_dbg(" den=%u ", den); */
         if (den == 0)
         {
-            /* dbg("div by 0!\n"); */
+            /* olsr_dbg("div by 0!\n"); */
             den = 1u;
         }
 
@@ -282,7 +283,7 @@ uint8_t seconds2olsr(uint32_t seconds)
     }
     /* a = a & 0x0Fu; */
 
-    /* dbg(" a=%u\n", a); */
+    /* olsr_dbg(" a=%u\n", a); */
 
     /* if 'a' is equal to 16: increment 'b' by one, and set 'a' to 0 */
     if (16u == a) {
@@ -297,16 +298,16 @@ uint32_t olsr2seconds(uint8_t olsr)
 {
     uint8_t a, b;
     uint16_t seconds;
-    /* dbg("olsr format: %u -- ", olsr); */
+    /* olsr_dbg("olsr format: %u -- ", olsr); */
     a = (olsr >> 4) & 0xFu;
     b = olsr & 0x0f;
-    /* dbg("o2s: a=%u, b=%u\n", a,b); */
+    /* olsr_dbg("o2s: a=%u, b=%u\n", a,b); */
     if (b < 4)
         seconds = (uint16_t)(((1u << b) + (uint16_t)(((uint16_t)(a << b) >> 4u) & 0xFu)) >> OLSR_C_SHIFT);
     else
         seconds = (uint16_t)(((1u << b) + (uint16_t)(((uint16_t)(a << (b - 4))) & 0xFu)) >> OLSR_C_SHIFT);
 
-    /* dbg("o2s: seconds: %u\n", seconds); */
+    /* olsr_dbg("o2s: seconds: %u\n", seconds); */
     return seconds;
 }
 
@@ -363,7 +364,7 @@ void olsr_process_out(pico_time now, void *arg)
         ohdr->seq = short_be((uint16_t)(odev->pkt_counter)++);
         bcast.addr = (addr->netmask.addr & addr->address.addr) | (~addr->netmask.addr);
         if ( 0 > pico_socket_sendto(udpsock, p->buf, p->len, &bcast, OLSR_PORT)) {
-            dbg("olsr send\n");
+            olsr_dbg("olsr send\n");
         }
     } else {
         while(pdev) {
@@ -374,7 +375,7 @@ void olsr_process_out(pico_time now, void *arg)
 
             bcast.addr = (addr->netmask.addr & addr->address.addr) | (~addr->netmask.addr);
             if ( 0 > pico_socket_sendto(udpsock, p->buf, p->len, &bcast, OLSR_PORT)) {
-                dbg("olsr send\n");
+                olsr_dbg("olsr send\n");
             }
 
             pdev = pdev->next;
@@ -390,7 +391,7 @@ void olsr_process_out(pico_time now, void *arg)
 static void olsr_scheduled_output(uint32_t when, void *buffer, uint16_t size, struct pico_device *pdev)
 {
     struct olsr_fwd_pkt *p;
-    /* dbg("Scheduling olsr packet, type:%s, size: %x\n", when == OLSR_HELLO_INTERVAL?"HELLO":"TC", size); */
+    /* olsr_dbg("Scheduling olsr packet, type:%s, size: %x\n", when == OLSR_HELLO_INTERVAL?"HELLO":"TC", size); */
     if ((buffer_mem_used + DGRAM_MAX_SIZE) > MAX_OLSR_MEM) {
         PICO_FREE(buffer);
         return;
@@ -437,7 +438,7 @@ static void refresh_routes(void)
             } else if (lnk) {
                 struct olsr_route_entry *e = PICO_ZALLOC(sizeof (struct olsr_route_entry));
                 if (!e) {
-                    dbg("olsr: adding local route entry\n");
+                    olsr_dbg("olsr: adding local route entry\n");
                     OOM();
                     return;
                 }
@@ -657,7 +658,7 @@ static void olsr_compose_hello_dgram(struct pico_device *pdev, struct pico_ipv4_
         if (DGRAM_MAX_SIZE > size) {
             r = olsr_build_hello_neighbors(dgram + size, DGRAM_MAX_SIZE - size, &last_neighbor);
             if (r == 0) {
-                /* dbg("Building hello message\n"); */
+                /* olsr_dbg("Building hello message\n"); */
                 PICO_FREE(dgram);
                 return;
             }
@@ -703,7 +704,7 @@ void recv_mid(uint8_t *buffer, uint32_t len, struct olsr_route_entry *origin)
         if (!e) {
             e = PICO_ZALLOC(sizeof(struct olsr_route_entry));
             if (!e) {
-                dbg("olsr allocating route\n");
+                olsr_dbg("olsr allocating route\n");
                 OOM();
                 return;
             }
@@ -757,7 +758,7 @@ void recv_hello(uint8_t *buffer, uint32_t len, struct olsr_route_entry *origin,
         if (!e) {
             e = PICO_ZALLOC(sizeof(struct olsr_route_entry));
             if (!e) {
-                dbg("olsr allocating route\n");
+                olsr_dbg("olsr allocating route\n");
                 OOM();
                 return;
             }
@@ -812,7 +813,7 @@ uint32_t reconsider_topology(uint8_t *buf, uint32_t size, struct olsr_route_entr
         e->advertised_tc = PICO_ZALLOC(size);
         if (!e->advertised_tc) {
             OOM();
-            dbg("Allocating forward packet\n");
+            olsr_dbg("Allocating forward packet\n");
             return 0;
         }
 
@@ -848,7 +849,7 @@ uint32_t reconsider_topology(uint8_t *buf, uint32_t size, struct olsr_route_entr
                 olsr_route_add(rt);
             }
         }
-        /* dbg("Routes changed...\n"); */
+        /* olsr_dbg("Routes changed...\n"); */
     }
 
     return retval;
@@ -889,7 +890,7 @@ static void olsr_recv(uint8_t *buffer, uint32_t len)
         origin = get_route_by_address(Local_interfaces, msg->orig.addr);
 
         if(pico_ipv4_link_find(&msg->orig) != NULL) {
-            /* dbg("rebound\n"); */
+            /* olsr_dbg("rebound\n"); */
             parsed += short_be(msg->size);
             continue;
         }
@@ -947,7 +948,7 @@ static void olsr_recv(uint8_t *buffer, uint32_t len)
                 msg->ttl = 0;
             } else {
                 recv_mid(buffer + parsed + sizeof(struct olsrmsg), (uint32_t)(short_be(msg->size) - (sizeof(struct olsrmsg))), origin);
-                /* dbg("MID forwarded from origin %08x (seq: %u)\n", long_be(msg->orig.addr), short_be(msg->seq)); */
+                /* olsr_dbg("MID forwarded from origin %08x (seq: %u)\n", long_be(msg->orig.addr), short_be(msg->seq)); */
                 origin->seq = short_be(msg->seq);
             }
 
@@ -958,7 +959,7 @@ static void olsr_recv(uint8_t *buffer, uint32_t len)
                 if ((origin->seq != 0) && (!fresher(short_be(msg->seq), origin->seq))) {
                     msg->ttl = 0;
                 } else {
-                    /* dbg("TC forwarded from origin %08x (seq: %u)\n", long_be(msg->orig.addr), short_be(msg->seq)); */
+                    /* olsr_dbg("TC forwarded from origin %08x (seq: %u)\n", long_be(msg->orig.addr), short_be(msg->seq)); */
                     origin->seq = short_be(msg->seq);
                 }
             }
@@ -1055,7 +1056,7 @@ void pico_olsr_init(void)
         0
     };
     uint16_t port = OLSR_PORT;
-    dbg("OLSR initialized.\n");
+    olsr_dbg("OLSR initialized.\n");
     if (!udpsock) {
         udpsock = pico_socket_open(PICO_PROTO_IPV4, PICO_PROTO_UDP, &wakeup);
         if (udpsock)
@@ -1096,7 +1097,7 @@ int pico_olsr_add(struct pico_device *dev)
         return -1;
     }
 
-    /* dbg("OLSR: Adding device %s\n", dev->name); */
+    /* olsr_dbg("OLSR: Adding device %s\n", dev->name); */
     od = PICO_ZALLOC(sizeof(struct olsr_dev_entry));
     if (!od) {
         pico_err = PICO_ERR_ENOMEM;
@@ -1113,11 +1114,11 @@ int pico_olsr_add(struct pico_device *dev)
         lnk = pico_ipv4_link_by_dev_next(dev, lnk);
         if (lnk) {
             struct olsr_route_entry *e = PICO_ZALLOC(sizeof(struct olsr_route_entry));
-            /* dbg("OLSR: Found IP address %08x\n", long_be(lnk->address.addr)); */
+            /* olsr_dbg("OLSR: Found IP address %08x\n", long_be(lnk->address.addr)); */
             pico_ipv4_to_string(ipaddr, (lnk->address.addr));
-            /* dbg("OLSR: Found IP address %s\n", ipaddr); */
+            /* olsr_dbg("OLSR: Found IP address %s\n", ipaddr); */
             if (!e) {
-                dbg("olsr allocating route\n");
+                olsr_dbg("olsr allocating route\n");
                 pico_err = PICO_ERR_ENOMEM;
                 return -1;
             }
diff --git a/test/unit/modunit_pico_aodv.c b/test/unit/modunit_pico_aodv.c
new file mode 100644
index 000000000..5c3fe1085
--- /dev/null
+++ b/test/unit/modunit_pico_aodv.c
@@ -0,0 +1,302 @@
+#include <pico_stack.h>
+#include <pico_tree.h>
+#include <pico_socket.h>
+#include <pico_aodv.h>
+#include <pico_device.h>
+#include <pico_ipv4.h>
+#include "modules/pico_aodv.c"
+#include "check.h"
+
+
+START_TEST(tc_aodv_node_compare)
+{
+    struct pico_aodv_node a, b;
+    a.dest.ip4.addr = long_be(1);
+    b.dest.ip4.addr = long_be(2);
+
+    fail_if(aodv_node_compare(&a, &b) >= 0);
+    a.dest.ip4.addr = long_be(3);
+    fail_if(aodv_node_compare(&a, &b) <= 0);
+    b.dest.ip4.addr = long_be(3);
+    fail_if(aodv_node_compare(&a, &b) != 0);
+}
+END_TEST
+
+START_TEST(tc_aodv_dev_cmp)
+{
+    struct pico_device a, b;
+    a.hash = 1;
+    b.hash = 2;
+    fail_if(aodv_dev_cmp(&a, &b) >= 0);
+    a.hash = 3;
+    fail_if(aodv_dev_cmp(&a, &b) <= 0);
+    b.hash = 3;
+    fail_if(aodv_dev_cmp(&a, &b) != 0);
+
+}
+END_TEST
+
+START_TEST(tc_get_node_by_addr)
+{
+    struct pico_aodv_node a;
+    union pico_address test;
+    a.dest.ip4.addr = long_be(10);
+    test.ip4.addr = long_be(10);
+
+    pico_tree_insert(&aodv_nodes, &a);
+
+    fail_if(get_node_by_addr(&test) != &a);
+    pico_tree_delete(&aodv_nodes, &a);
+    fail_if(get_node_by_addr(&test) != NULL);
+
+}
+END_TEST
+
+static int set_bcast_link_called = 0;
+void pico_ipv4_route_set_bcast_link(struct pico_ipv4_link *link)
+{
+    fail_if(link);
+    set_bcast_link_called++;
+}
+
+START_TEST(tc_pico_aodv_set_dev)
+{
+    struct pico_device *dev = NULL;
+    pico_aodv_set_dev(dev);
+    fail_if(set_bcast_link_called != 1);
+}
+END_TEST
+
+START_TEST(tc_aodv_peer_refresh)
+{
+   /* TODO: test this: static int aodv_peer_refresh(struct pico_aodv_node *node, uint32_t seq) */
+    struct pico_aodv_node node;
+    memset(&node, 0, sizeof(node));
+    node.dseq = 0xFFFF;
+    fail_if(aodv_peer_refresh(&node, 10) != 0); /* should succeed, because SYNC flag is not yet set... */
+    fail_if(node.flags & PICO_AODV_NODE_SYNC == 0); /* Flag should be set after last call... */
+    fail_if(aodv_peer_refresh(&node, 5) == 0); /* should FAIL, because seq number is lower...  */
+    fail_if(aodv_peer_refresh(&node, 10) == 0); /* should FAIL, because seq number is still the same...  */
+    fail_if(aodv_peer_refresh(&node, 15) != 0); /* should succeed, because seq number is now bigger...  */
+    fail_if(node.dseq != 15);
+}
+END_TEST
+
+static int called_route_add = 0;
+static uint32_t route_add_gw = 0u;
+static int route_add_metric = 0;
+int pico_ipv4_route_add(struct pico_ip4 address, struct pico_ip4 netmask, struct pico_ip4 gateway, int metric, struct pico_ipv4_link *link)
+{
+    called_route_add++;
+    route_add_gw = gateway.addr;
+    route_add_metric = metric;
+    return 0;
+}
+
+START_TEST(tc_aodv_elect_route)
+{
+    struct pico_aodv_node node;
+    union pico_address gateway;
+    memset(&node, 0, sizeof(node));
+    gateway.ip4.addr = 0x55555555;
+
+    called_route_add = 0;
+    aodv_elect_route(&node, NULL, 150, NULL);
+    fail_if(called_route_add != 1); /* Not active, should succeed */
+    fail_if(route_add_gw != 0u);
+    fail_if(route_add_metric != 1);
+
+    called_route_add = 0;
+    route_add_metric = 0;
+    route_add_gw = 0u;
+    node.flags = PICO_AODV_NODE_ROUTE_DOWN | PICO_AODV_NODE_ROUTE_UP;
+    aodv_elect_route(&node, &gateway, 150, NULL);
+    fail_if(called_route_add != 0); /* Already active, existing metric is lower */
+    
+    called_route_add = 0;
+    route_add_metric = 0;
+    route_add_gw = 0u;
+    node.metric = 22;
+    aodv_elect_route(&node, &gateway, 15, NULL);
+    fail_if(called_route_add != 1); /* Already active, existing metric is higher */
+    fail_if(route_add_metric != 16);
+    fail_if(route_add_gw != 0x55555555);
+
+}
+END_TEST
+
+START_TEST(tc_aodv_peer_new)
+{
+   /* TODO: test this: static struct pico_aodv_node *aodv_peer_new(const union pico_address *addr) */
+}
+END_TEST
+START_TEST(tc_aodv_peer_eval)
+{
+   /* TODO: test this: static struct pico_aodv_node *aodv_peer_eval(union pico_address *addr, uint32_t seq, int valid_seq) */
+}
+END_TEST
+START_TEST(tc_aodv_lifetime)
+{
+   /* TODO: test this: static uint32_t aodv_lifetime(struct pico_aodv_node *node) */
+}
+END_TEST
+START_TEST(tc_aodv_send_reply)
+{
+   /* TODO: test this: static void aodv_send_reply(struct pico_aodv_node *node, struct pico_aodv_rreq *req, int node_is_local, struct pico_msginfo *info) */
+}
+END_TEST
+START_TEST(tc_aodv_send_req)
+{
+   /* TODO: test this: static int aodv_send_req(struct pico_aodv_node *node); */
+}
+END_TEST
+START_TEST(tc_aodv_reverse_path_discover)
+{
+   /* TODO: test this: static void aodv_reverse_path_discover(pico_time now, void *arg) */
+}
+END_TEST
+START_TEST(tc_aodv_recv_valid_rreq)
+{
+   /* TODO: test this: static void aodv_recv_valid_rreq(struct pico_aodv_node *node, struct pico_aodv_rreq *req, struct pico_msginfo *info) */
+}
+END_TEST
+START_TEST(tc_aodv_parse_rreq)
+{
+   /* TODO: test this: static void aodv_parse_rreq(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo) */
+}
+END_TEST
+START_TEST(tc_aodv_parse_rrep)
+{
+   /* TODO: test this: static void aodv_parse_rrep(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo) */
+}
+END_TEST
+START_TEST(tc_aodv_parse_rerr)
+{
+   /* TODO: test this: static void aodv_parse_rerr(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo) */
+}
+END_TEST
+START_TEST(tc_aodv_parse_rack)
+{
+   /* TODO: test this: static void aodv_parse_rack(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo) */
+}
+END_TEST
+START_TEST(tc_pico_aodv_parse)
+{
+   /* TODO: test this: static void pico_aodv_parse(union pico_address *from, uint8_t *buf, int len, struct pico_msginfo *msginfo) */
+}
+END_TEST
+START_TEST(tc_pico_aodv_socket_callback)
+{
+   /* TODO: test this: static void pico_aodv_socket_callback(uint16_t ev, struct pico_socket *s) */
+}
+END_TEST
+START_TEST(tc_aodv_make_rreq)
+{
+   /* TODO: test this: static void aodv_make_rreq(struct pico_aodv_node *node, struct pico_aodv_rreq *req) */
+}
+END_TEST
+START_TEST(tc_aodv_retrans_rreq)
+{
+   /* TODO: test this: static void aodv_retrans_rreq(pico_time now, void *arg) */
+}
+END_TEST
+START_TEST(tc_pico_aodv_expired)
+{
+   /* TODO: test this: static void pico_aodv_expired(struct pico_aodv_node *node) */
+}
+END_TEST
+START_TEST(tc_pico_aodv_collector)
+{
+   /* TODO: test this: static void pico_aodv_collector(pico_time now, void *arg) */
+}
+END_TEST
+
+
+Suite *pico_suite(void)                       
+{
+    Suite *s = suite_create("PicoTCP");             
+
+    TCase *TCase_aodv_node_compare = tcase_create("Unit test for aodv_node_compare");
+    TCase *TCase_aodv_dev_cmp = tcase_create("Unit test for aodv_dev_cmp");
+    TCase *TCase_get_node_by_addr = tcase_create("Unit test for get_node_by_addr");
+    TCase *TCase_pico_aodv_set_dev = tcase_create("Unit test for pico_aodv_set_dev");
+    TCase *TCase_aodv_peer_refresh = tcase_create("Unit test for aodv_peer_refresh");
+    TCase *TCase_aodv_elect_route = tcase_create("Unit test for aodv_elect_route");
+    TCase *TCase_aodv_peer_new = tcase_create("Unit test for aodv_peer_new");
+    TCase *TCase_aodv_peer_eval = tcase_create("Unit test for aodv_peer_eval");
+    TCase *TCase_aodv_lifetime = tcase_create("Unit test for aodv_lifetime");
+    TCase *TCase_aodv_send_reply = tcase_create("Unit test for aodv_send_reply");
+    TCase *TCase_aodv_send_req = tcase_create("Unit test for aodv_send_req");
+    TCase *TCase_aodv_reverse_path_discover = tcase_create("Unit test for aodv_reverse_path_discover");
+    TCase *TCase_aodv_recv_valid_rreq = tcase_create("Unit test for aodv_recv_valid_rreq");
+    TCase *TCase_aodv_parse_rreq = tcase_create("Unit test for aodv_parse_rreq");
+    TCase *TCase_aodv_parse_rrep = tcase_create("Unit test for aodv_parse_rrep");
+    TCase *TCase_aodv_parse_rerr = tcase_create("Unit test for aodv_parse_rerr");
+    TCase *TCase_aodv_parse_rack = tcase_create("Unit test for aodv_parse_rack");
+    TCase *TCase_pico_aodv_parse = tcase_create("Unit test for pico_aodv_parse");
+    TCase *TCase_pico_aodv_socket_callback = tcase_create("Unit test for pico_aodv_socket_callback");
+    TCase *TCase_aodv_make_rreq = tcase_create("Unit test for aodv_make_rreq");
+    TCase *TCase_aodv_retrans_rreq = tcase_create("Unit test for aodv_retrans_rreq");
+    TCase *TCase_pico_aodv_expired = tcase_create("Unit test for pico_aodv_expired");
+    TCase *TCase_pico_aodv_collector = tcase_create("Unit test for pico_aodv_collector");
+
+
+    tcase_add_test(TCase_aodv_node_compare, tc_aodv_node_compare);
+    suite_add_tcase(s, TCase_aodv_node_compare);
+    tcase_add_test(TCase_aodv_dev_cmp, tc_aodv_dev_cmp);
+    suite_add_tcase(s, TCase_aodv_dev_cmp);
+    tcase_add_test(TCase_get_node_by_addr, tc_get_node_by_addr);
+    suite_add_tcase(s, TCase_get_node_by_addr);
+    tcase_add_test(TCase_pico_aodv_set_dev, tc_pico_aodv_set_dev);
+    suite_add_tcase(s, TCase_pico_aodv_set_dev);
+    tcase_add_test(TCase_aodv_peer_refresh, tc_aodv_peer_refresh);
+    suite_add_tcase(s, TCase_aodv_peer_refresh);
+    tcase_add_test(TCase_aodv_elect_route, tc_aodv_elect_route);
+    suite_add_tcase(s, TCase_aodv_elect_route);
+    tcase_add_test(TCase_aodv_peer_new, tc_aodv_peer_new);
+    suite_add_tcase(s, TCase_aodv_peer_new);
+    tcase_add_test(TCase_aodv_peer_eval, tc_aodv_peer_eval);
+    suite_add_tcase(s, TCase_aodv_peer_eval);
+    tcase_add_test(TCase_aodv_lifetime, tc_aodv_lifetime);
+    suite_add_tcase(s, TCase_aodv_lifetime);
+    tcase_add_test(TCase_aodv_send_reply, tc_aodv_send_reply);
+    suite_add_tcase(s, TCase_aodv_send_reply);
+    tcase_add_test(TCase_aodv_send_req, tc_aodv_send_req);
+    suite_add_tcase(s, TCase_aodv_send_req);
+    tcase_add_test(TCase_aodv_reverse_path_discover, tc_aodv_reverse_path_discover);
+    suite_add_tcase(s, TCase_aodv_reverse_path_discover);
+    tcase_add_test(TCase_aodv_recv_valid_rreq, tc_aodv_recv_valid_rreq);
+    suite_add_tcase(s, TCase_aodv_recv_valid_rreq);
+    tcase_add_test(TCase_aodv_parse_rreq, tc_aodv_parse_rreq);
+    suite_add_tcase(s, TCase_aodv_parse_rreq);
+    tcase_add_test(TCase_aodv_parse_rrep, tc_aodv_parse_rrep);
+    suite_add_tcase(s, TCase_aodv_parse_rrep);
+    tcase_add_test(TCase_aodv_parse_rerr, tc_aodv_parse_rerr);
+    suite_add_tcase(s, TCase_aodv_parse_rerr);
+    tcase_add_test(TCase_aodv_parse_rack, tc_aodv_parse_rack);
+    suite_add_tcase(s, TCase_aodv_parse_rack);
+    tcase_add_test(TCase_pico_aodv_parse, tc_pico_aodv_parse);
+    suite_add_tcase(s, TCase_pico_aodv_parse);
+    tcase_add_test(TCase_pico_aodv_socket_callback, tc_pico_aodv_socket_callback);
+    suite_add_tcase(s, TCase_pico_aodv_socket_callback);
+    tcase_add_test(TCase_aodv_make_rreq, tc_aodv_make_rreq);
+    suite_add_tcase(s, TCase_aodv_make_rreq);
+    tcase_add_test(TCase_aodv_retrans_rreq, tc_aodv_retrans_rreq);
+    suite_add_tcase(s, TCase_aodv_retrans_rreq);
+    tcase_add_test(TCase_pico_aodv_expired, tc_pico_aodv_expired);
+    suite_add_tcase(s, TCase_pico_aodv_expired);
+    tcase_add_test(TCase_pico_aodv_collector, tc_pico_aodv_collector);
+    suite_add_tcase(s, TCase_pico_aodv_collector);
+return s;
+}
+                      
+int main(void)                      
+{                       
+    int fails;                      
+    Suite *s = pico_suite();                        
+    SRunner *sr = srunner_create(s);                        
+    srunner_run_all(sr, CK_NORMAL);                     
+    fails = srunner_ntests_failed(sr);                      
+    srunner_free(sr);                       
+    return fails;                       
+}
diff --git a/test/units.sh b/test/units.sh
index 93e1e17c7..e8fbfbfe2 100755
--- a/test/units.sh
+++ b/test/units.sh
@@ -15,6 +15,7 @@ rm -f /tmp/pico-mem-report-*
 ./build/test/modunit_ipfilter.elf || exit 1
 ./build/test/modunit_queue.elf || exit 1
 ./build/test/modunit_tftp.elf || exit 1
+./build/test/modunit_aodv.elf || exit 1
 
 MAXMEM=`cat /tmp/pico-mem-report-* | sort -r -n |head -1`
 echo
